<?php
$base_config_path = dirname(dirname(dirname(dirname(__FILE__)))) . '/rbspayment_alfabankby/config.php';
$user_config_path = dirname(dirname(dirname(dirname(__FILE__)))) . '/rbspayment_alfabankby/include.php';
include($base_config_path);
include($user_config_path);
include_once 'lib/DiscountHelper.php';
if (!class_exists('msPaymentInterface')) {
require_once dirname(dirname(dirname(__FILE__))) . '/model/minishop2/mspaymenthandler.class.php';
}
if(!defined('RBSPAYMENT_ALFABANKBY_PROD_URL_ALT_PREFIX')) {
define('RBSPAYMENT_ALFABANKBY_PROD_URL_ALT_PREFIX', '');
}
if(!defined('RBSPAYMENT_ALFABANKBY_TEST_URL_ALTERNATIVE_DOMAIN')) {
define('RBSPAYMENT_ALFABANKBY_TEST_URL_ALTERNATIVE_DOMAIN', '');
}
if(!defined('RBSPAYMENT_ALFABANKBY_PROD_URL_ALTERNATIVE_DOMAIN')) {
define('RBSPAYMENT_ALFABANKBY_PROD_URL_ALTERNATIVE_DOMAIN', '');
}
class RBSPaymentalfabankby extends msPaymentHandler implements msPaymentInterface
{
const module_version = "2.0.1";
/**
* CMS
*
* @var string
*/
const cms_name = 'modx-revo-ms2';
/**
*
* @var string
*/
const merchant_login = RBSPAYMENT_ALFABANKBY_MERCHANT_LOGIN;
/**
*
* @var string
*/
const merchant_password = RBSPAYMENT_ALFABANKBY_MERCHANT_PASSWORD;
/**
*
* @var string
*/
const success_url = RBSPAYMENT_ALFABANKBY_SUCCESS_URL;
/**
*
* @var string
*/
const test_mode = RBSPAYMENT_ALFABANKBY_TEST_MODE;
/**
*
* @var string
*/
const callback_mode = RBSPAYMENT_ALFABANKBY_ENABLE_CALLBACK;
/**
*
* @var string
*/
const error_url = RBSPAYMENT_ALFABANKBY_ERROR_URL;
/**
*
* @var string
*/
const test_url = RBSPAYMENT_ALFABANKBY_TEST_URL;
/**
*
* @var string
*/
const prod_url = RBSPAYMENT_ALFABANKBY_PROD_URL;
/**
*
* @var string
*/
const test_url_alt = RBSPAYMENT_ALFABANKBY_TEST_URL_ALTERNATIVE_DOMAIN;
/**
*
* @var string
*/
const prod_url_alt = RBSPAYMENT_ALFABANKBY_PROD_URL_ALTERNATIVE_DOMAIN;
/**
*
* @var string
*/
const prod_url_alt_prefix = RBSPAYMENT_ALFABANKBY_PROD_URL_ALT_PREFIX;
/**
*
*
* @var integer
*/
const vat_rate = RBSPAYMENT_ALFABANKBY_VAT_RATE;
/**
*
*
* @var integer
*/
const tax_system = RBSPAYMENT_ALFABANKBY_TAX_SYSTEM;
/**
*
* @var boolean
*/
const logging = RBSPAYMENT_ALFABANKBY_ENABLE_LOGGING;
const two_stage = RBSPAYMENT_ALFABANKBY_TWO_STAGE;
const send_order = RBSPAYMENT_ALFABANKBY_SEND_ORDER;
const ffd_version = RBSPAYMENT_ALFABANKBY_FFD_VERSION;
const ffd_payment_method = RBSPAYMENT_ALFABANKBY_FFD_PAYMENT_METHOD;
const ffd_payment_method_delivery = RBSPAYMENT_ALFABANKBY_FFD_PAYMENT_METHOD_DELIVERY;
const ffd_payment_object = RBSPAYMENT_ALFABANKBY_FFD_PAYMENT_OBJECT;
const ffd_measurement_name = RBSPAYMENT_ALFABANKBY_MEASUREMENT_NAME;
const ffd_measurement_code = RBSPAYMENT_ALFABANKBY_MEASUREMENT_CODE;
const currency_codes = RBSPAYMENT_ALFABANKBY_CURRENCY_CODES;
const customer_email_send = RBSPAYMENT_ALFABANKBY_CUSTOMER_EMAIL_SEND;
const skip_confirmation_step = RBSPAYMENT_ALFABANKBY_SKIP_CONFIRMATION_STEP;
const url_separator = '_';
public $config;
public $modx;
function __construct(xPDOObject $object, $config = array())
{
$this->modx = &$object->xpdo;
$siteUrl = $this->modx->getOption('site_url');
$assetsUrl = $this->modx->getOption('minishop2.assets_url', $config, $this->modx->getOption('assets_url') . 'components/rbspayment_alfabankby/');
$gateway_prod_url = $this->getGateProdUrl(self::merchant_login, self::prod_url_alt_prefix, self::prod_url, self::prod_url_alt);
$this->config = array_merge(array(
'gatewayUrl' => self::test_mode ? self::test_url : $gateway_prod_url,
'gate_url_test' => self::test_url,
'gate_url_prod' => $gateway_prod_url,
'gate_url_test_for_update' => self::test_url,
'gate_url_prod_for_update' => $gateway_prod_url,
'returnUrl' => $siteUrl . substr($assetsUrl, 1) . 'result.php',
'callbackUrl' => $siteUrl . substr($assetsUrl, 1) . 'result.php?isCallback=1',
'callback_mode' => self::callback_mode,
'userName' => self::merchant_login,
'password' => self::merchant_password,
'jsonParams' => array(
'CMS' => self::cms_name,
'Module-Version' => self::module_version
),
'logging' => self::logging,
'ffd_version' => self::ffd_version,
'paymentMethod' => self::ffd_payment_method,
'paymentObject' => self::ffd_payment_object,
'tax_type' => self::vat_rate,
), $config);
}
/**
*
*
* @param mixed[]
* @return mixed[]
*/
public function send(msOrder $order)
{
$id = $order->get('id');
if (self::two_stage === true) {
$method = 'registerPreAuth.do';
} else {
$method = 'register.do';
}
$data = array(
'orderNumber' => $order->get('num') . self::url_separator . $id . self::url_separator . time(),
'amount' => round($order->get('cost') * 100),
'userName' => $this->config['userName'],
'password' => $this->config['password'],
'returnUrl' => $this->config['returnUrl'],
);
if ($this->modx->user->isAuthenticated('web')) {
$user = $this->modx->getUser();
$profile = $user->getOne('Profile');
$id = $user->get('id');
$email = $profile->get('email');
$site_url = $this->modx->getOption('site_url');
$data['clientID'] = $this->createStoredCredentialClientID($id, $email, $site_url);
}
if (self::send_order === true) {
$order_billing_phone = preg_replace('/\D+/', '', $_POST['phone']);
$order_billing_email = $_POST['email'];
$items = array();
$itemsCnt = 1;
$products = $order->getMany('Products');
$i = 0;
foreach ($products as $val) {
$tax_type = 0;
/** @var msProduct $product */
$name = $val->get('name');
if (empty($name) && $product = $val->getOne('Product')) {
$name = $product->get('pagetitle');
}
$price = $val->get('price') * 100;
$count = $val->get('count');
$item['positionId'] = $itemsCnt++;
$item['name'] = $name;
$item['quantity'] = array(
'value' => $val->get('count'),
'measure' => $this->config['ffd_version'] == "v1.2" ? self::ffd_measurement_code : self::ffd_measurement_name
);
$item['itemAmount'] = $price * $count;
$item['itemCode'] = $val->get('id');
$item['tax'] = array(
'taxType' => $this->config['tax_type']
);
$item['itemPrice'] = str_replace(',', '.', $price);
$i++;
$item['itemAttributes'] = [
'attributes' => [
[
'name' => 'paymentMethod',
'value' => $this->config['paymentMethod']
],
[
'name' => 'paymentObject',
'value' => $this->config['paymentObject']
],
]
];
$items[] = $item;
}
$delivery_cost = $order->get('delivery_cost');
if ($delivery_cost > 0) {
$delivery_info = $order->getOne('Delivery')->toArray();
$item_delivery = [
'positionId' => $itemsCnt++,
'name' => $delivery_info['name'],
'quantity' => array(
'value' => 1,
'measure' => $this->config['ffd_version'] == "v1.2" ? self::ffd_measurement_code : self::ffd_measurement_name
),
'itemAmount' => round($delivery_cost * 100),
'itemCode' => $delivery_info['id'] . "_DELIVERY",
'itemPrice' => round($delivery_cost * 100),
'tax' => array(
'taxType' => $this->config['tax_type'],
)
];
$item_delivery['itemAttributes'] = [
'attributes' => [
[
'name' => 'paymentMethod',
'value' => self::ffd_payment_method_delivery,
],
[
'name' => 'paymentObject',
'value' => 4
],
]
];
array_push($items, $item_delivery);
}
$DiscountHelper = new DiscountHelper();
$discount = $DiscountHelper->discoverDiscount($data['amount'], $items);
if ($discount > 0) {
$DiscountHelper->setOrderDiscount($discount);
$recalculatedPositions = $DiscountHelper->normalizeItems($items);
$recalculatedAmount = $DiscountHelper->getResultAmount();
$items = $recalculatedPositions;
}

$order_bundle = array(
'orderCreationDate' => time(),
'customerDetails' => array(
'phone' => $order_billing_phone,
),
'cartItems' => array('items' => $items)
);
if ($order_billing_email) {
$order_bundle['customerDetails']['email'] = $order_billing_email;
$this->config['jsonParams']['email'] = $_POST['email'];
}
$data['orderBundle'] = json_encode($order_bundle);
$data['jsonParams'] = json_encode($this->config['jsonParams']);
$data['taxSystem'] = self::tax_system;
}
if ($this->isCallbackMode()) {
$this->updateCallback(array(
'test_mode' => self::test_mode,
'callback_http_method' => 'GET',
'callbacks_enabled' => true,
'callback_addresses' => $this->config['callbackUrl'],
'callback_operations' => 'approved,deposited,declinedByTimeout'
), $this->config['userName'], $this->config['password']);
}
$response = $this->gateway($method, $data);
if ($response['errorCode'] > 0) {
return $this->success('', array('error' => 1, 'code' => $response['errorCode'], 'message' => $response['errorMessage'],));
}
return $this->success('', array('error' => 0, 'redirect' => $response['formUrl']));
}
/**
*
*
* @param string
* @param array []
* @return mixed[]
*/
public function gateway($method, $data)
{
$gate_url = $this->config['gatewayUrl'] . $method;
$curl_opt = array(
CURLOPT_URL => $gate_url,
CURLOPT_RETURNTRANSFER => true,
CURLOPT_POST => true,
CURLOPT_POSTFIELDS => http_build_query($data),
CURLOPT_HTTPHEADER => array('CMS:' . self::cms_name, 'Module-Version: ' . self::module_version),
CURLOPT_SSLVERSION => 6
);
$ssl_verify_peer = false;
$curl_opt[CURLOPT_SSL_VERIFYPEER] = $ssl_verify_peer;
$curl = curl_init();
curl_setopt_array($curl, $curl_opt);
$response = curl_exec($curl);
if ($response) {
$response = json_decode($response, true);
}
if ($response === false) {
$response = array(
'errorCode' => 999,
'errorMessage' => curl_error($curl),
);
}
curl_close($curl);
if ($this->config['logging']) {
$message = "\n----============----\n";
$message .= 'METHOD:' . $gate_url  . "\n" . 'REQUEST_DATA:' . "\n" .  print_r($data, 1)  . "\n" .  'REQUEST_RESPONSE:' . "\n" .  print_r(json_encode($response), 1);
$message .= "\n";
$this->modx->log(modX::LOG_LEVEL_ERROR, $message);
}
return $response;
}
/**
*
* @param string id transaction
*/
public function receiver($orderId)
{
if (!$orderId) {
return false;
}
if (isset($_REQUEST['isCallback'])) {
if ($_REQUEST['operation'] != 'deposited' && $_REQUEST['operation'] != 'approved') {
return true;
}
}
$data = [
'orderId' => $orderId,
'userName' => $this->config['userName'],
'password' => $this->config['password'],
];
if (!isset($_REQUEST['isCallback']) && $this->isCallbackMode()) {
$this->config['logging'] = false;
}
$response = $this->gateway('getOrderStatusExtended.do', $data);
if (($response['errorCode'] == 0) && (($response['orderStatus'] == 1) || ($response['orderStatus'] == 2))) {
$ms2 = $this->modx->getService('miniShop2');
if (isset($_REQUEST['isCallback']) || !$this->isCallbackMode()) {
$orderNumber = explode(self::url_separator, $response['orderNumber']);
array_pop($orderNumber);
$order_id = end($orderNumber);
$ms2->changeOrderStatus($order_id, 2);
}
$redirectUrl =  strlen(self::success_url) < 9 ? '/' : self::success_url;
} else {
$redirectUrl = strlen(self::error_url) < 9 ? '/' : self::error_url;
}
if (isset($_REQUEST['isCallback'])) {
return json_encode(array('success' => true));
} else {
$this->modx->sendRedirect($redirectUrl);
}
}
public function returnMain()
{
$siteUrl = $this->modx->getOption('site_url');
$this->modx->sendRedirect($siteUrl);
}
/**
* BASE METHOD, DONT USE
*/
public function receive(msOrder $order)
{
}
private function getGateProdUrl($login, $prefix, $base_url, $alt_url)
{
if(!$prefix) {
return $base_url;
}
if (strlen($alt_url) > 0 && substr($login, 0, strlen($prefix)) == $prefix) {
$pattern = '/^https:\/\/[^\/]+/';
return preg_replace($pattern, rtrim($alt_url, '/'), $base_url);
}
return $base_url;
}
private function updateCallback($data,$login = false, $password = false)
{
if (!$login && !$password) {
return false;
}
$data['name'] = str_replace('-api', "", $login);
$replace_url_part = ['/rest', '/payment/'];
if ($data['test_mode'] == 1) {
$gate_url = str_replace($replace_url_part, '', $this->config['gate_url_test_for_update']);
if (substr($gate_url, -1) != '/') {
$gate_url .= '/';
}
$gate_url .= 'mportal/mvc/public/merchant/';
if (self::test_url_alt) {
$pattern = '/^https:\/\/[^\/]+/';
$gate_url = preg_replace($pattern, rtrim(self::test_url_alt, '/'), $gate_url);
}
} else {
$gate_url = str_replace($replace_url_part, '', $this->config['gate_url_prod_for_update']);
if (substr($gate_url, -1) != '/') {
$gate_url .= '/';
}
$gate_url .= 'mportal/mvc/public/merchant/';
if (self::prod_url_alt) {
$pattern = '/^https:\/\/[^\/]+/';
$gate_url = preg_replace($pattern, rtrim(self::prod_url_alt, '/'), $gate_url);
}
}
$gate_url .= 'update/' . $data['name'];
$headers = array(
'Content-Type:application/json',
'Authorization: Basic ' . base64_encode($login . ":" . $password),
);
$ch = curl_init();
curl_setopt_array($ch, array(
CURLOPT_HTTPHEADER => $headers,
CURLOPT_VERBOSE => true,
CURLOPT_SSL_VERIFYHOST => false,
CURLOPT_SSL_VERIFYPEER => false,
CURLOPT_URL => $gate_url,
CURLOPT_RETURNTRANSFER => true,
CURLOPT_POST => true,
CURLOPT_POSTFIELDS => json_encode($data),
));
$response = curl_exec($ch);
curl_close($ch);
if ($this->config['logging']) {
$message = "\n----============----\n";
$message .= 'METHOD callbackUpdate;' . "\n" . 'URL:' . $gate_url . "\n" . 'REQUEST_DATA: ' . "\n" .  print_r($data, 1)  . "\n" .  'REQUEST_RESPONSE:' . "\n" .  print_r($response, 1);
$message .= "\n";
$this->modx->log(modX::LOG_LEVEL_ERROR, $message);
}
}
public function isCallbackMode()
{
return $this->config['callback_mode'];
}
public function returnGateRequestLog($return_type, $request_data)
{
$message = "\n----============----\n";
$message .= 'Gateway: ' . $return_type . "\n" . 'DATA: ' . "\n" . print_r($request_data, 1);
$message .= "\n";
$this->modx->log(modX::LOG_LEVEL_ERROR, $message);
}
private function createStoredCredentialClientID($id, $email, $site_url)
{
return md5($id  .  $email  . $site_url);
}
}
